"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = exports.DIST_PATH = void 0;
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const framework_core_1 = require("@cloudbase/framework-core");
const mpPlugin_1 = require("./mpPlugin");
const framework_plugin_auth_1 = require("@cloudbase/framework-plugin-auth");
const lowcode_deployer_1 = __importStar(require("@cloudbase/lowcode-deployer"));
const lowcode_builder_1 = require("@cloudbase/lowcode-builder");
const lodash_1 = require("lodash");
const archiver_1 = __importDefault(require("archiver"));
const cos_nodejs_sdk_v5_1 = __importDefault(require("cos-nodejs-sdk-v5"));
exports.DIST_PATH = './dist';
const DEBUG_PATH = './debug';
const QRCODE_PATH = './qrcode.jpg';
const LOG_FILE = 'build.log';
const DEFAULT_CLOUDFUNCTION_ROOT_NAME = 'cloudfunctions';
const DEFAULT_INPUTS = {
    _inputFile: 'input.json',
    debug: false,
    runtime: process.env.CLOUDBASE_CIID ? lowcode_builder_1.RUNTIME.CI : lowcode_builder_1.RUNTIME.NONE,
    appId: 'test',
    buildTypeList: [lowcode_builder_1.BuildType.MP],
    generateMpType: lowcode_builder_1.GenerateMpType.APP,
    generateMpPath: '',
    subAppSerializeDataList: [],
    dependencies: [],
    plugins: [],
    operationService: {},
    extraData: { isComposite: false, compProps: {} },
    mpAppId: '',
    mpDeployPrivateKey: process.env.mpDeployPrivateKey || '',
    deployOptions: {
        mode: process.env.deployMode || lowcode_builder_1.DEPLOY_MODE.PREVIEW,
    },
    calsVersion: 'latest',
    ignoreInstall: false,
};
class LowCodePlugin extends framework_core_1.Plugin {
    constructor(name, api, inputs) {
        var _a, _b;
        super(name, api, inputs);
        this.name = name;
        this.api = api;
        this.inputs = inputs;
        this._timeMap = {};
        this._domain = [];
        this._enablePrivatelink = true;
        let inputJSONPath = path_1.default.resolve(this.api.projectPath, inputs._inputFile || DEFAULT_INPUTS._inputFile);
        let params = fs_extra_1.default.existsSync(inputJSONPath) ? fs_extra_1.default.readJsonSync(inputJSONPath) : {};
        this._originInputsStr = JSON.stringify(resolveInputs(inputs, params));
        this._resolvedInputs = resolveInputs(inputs, resolveInputs(params, DEFAULT_INPUTS));
        this._appPath = '';
        this._artifactOptions =
            this._resolvedInputs.runtime === lowcode_builder_1.RUNTIME.CI
                ? {
                    credential: this._resolvedInputs.credential,
                    bucket: ((_a = this._resolvedInputs.storage) === null || _a === void 0 ? void 0 : _a.bucket) || '',
                    region: ((_b = this._resolvedInputs.storage) === null || _b === void 0 ? void 0 : _b.region) || '',
                    baseKey: `lca/${this._resolvedInputs.appId}${process.env.CLOUDBASE_CIID ? `/${process.env.CLOUDBASE_CIID}` : ''}`,
                }
                : undefined;
        if (!this._resolvedInputs.mainAppSerializeData) {
            throw new Error('缺少必须参数: mainAppSerializeData');
        }
        this.api.logger.debug(`low-code plugin construct at ${Date.now()}`);
        this._time("low code lifetime");
    }
    _initDir() {
        fs_extra_1.default.emptyDirSync(path_1.default.resolve(this.api.projectPath, exports.DIST_PATH));
        fs_extra_1.default.removeSync(path_1.default.resolve(this.api.projectPath, DEBUG_PATH));
    }
    _subPluginConstructor(resolveInputs) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            if (resolveInputs.runtime === lowcode_builder_1.RUNTIME.CLI) {
                return;
            }
            let { buildTypeList, deployOptions } = resolveInputs;
            this._authPlugin = new framework_plugin_auth_1.plugin('auth', this.api, {
                configs: [
                    {
                        platform: 'NONLOGIN',
                        status: 'ENABLE',
                        platformId: '',
                        platformSecret: '',
                    },
                    {
                        platform: 'ANONYMOUS',
                        status: 'ENABLE',
                        platformId: '',
                        platformSecret: '',
                    },
                ],
            });
            if (buildTypeList.includes(lowcode_builder_1.BuildType.MP)) {
                if (deployOptions.mpDeployPrivateKey) {
                    fs_extra_1.default.writeFileSync(path_1.default.join(this.api.projectPath, `./private.${deployOptions.mpAppId}.key`), deployOptions.mpDeployPrivateKey, 'base64');
                }
                let projectJson = fs_extra_1.default.readJsonSync(path_1.default.resolve(this.api.projectPath, exports.DIST_PATH, 'project.config.json'));
                let { cloudfunctionRoot, miniprogramRoot = './' } = projectJson;
                let setting = {
                    es6: true,
                    es7: true,
                    minify: true,
                    codeProtect: false,
                    useCompilerPlugins: ['typescript'],
                };
                this._miniprogramePlugin = new mpPlugin_1.plugin('miniprograme', this.api, {
                    appid: deployOptions.mpAppId,
                    privateKeyPath: `./private.${deployOptions.mpAppId}.key`,
                    localPath: exports.DIST_PATH,
                    ignores: ['node_modules/**/*', LOG_FILE].concat(cloudfunctionRoot ? [path_1.default.join(cloudfunctionRoot, '**/*')] : []),
                    deployMode: deployOptions.mpAppId === deployOptions.targetMpAppId
                        ? deployOptions.mode === lowcode_builder_1.DEPLOY_MODE.DYNAMIC
                            ? lowcode_builder_1.DEPLOY_MODE.PREVIEW
                            : deployOptions.mode
                        : lowcode_builder_1.DEPLOY_MODE.UPLOAD,
                    uploadOptions: {
                        version: (deployOptions === null || deployOptions === void 0 ? void 0 : deployOptions.version) || '1.0.0',
                        desc: (deployOptions === null || deployOptions === void 0 ? void 0 : deployOptions.description) || '',
                        setting,
                        allowIgnoreUnusedFiles: true,
                    },
                    previewOptions: {
                        qrcodeOutputPath: path_1.default.resolve(this.api.projectPath, QRCODE_PATH),
                        pagePath: (_b = (_a = fs_extra_1.default.readJsonSync(path_1.default.resolve(this.api.projectPath, exports.DIST_PATH, miniprogramRoot, 'app.json'))) === null || _a === void 0 ? void 0 : _a.pages) === null || _b === void 0 ? void 0 : _b[0],
                        setting,
                        allowIgnoreUnusedFiles: true,
                    },
                    artifactOptions: this._artifactOptions,
                    deployerOprions: {
                        appId: this._resolvedInputs.appId,
                        envId: this.api.envId,
                        credential: yield this.api.getCredential(),
                    },
                });
            }
            else {
                const credential = yield this.api.getCredential();
                this._deployer = new lowcode_deployer_1.default({
                    api: this.api,
                    logger: this.api.logger,
                    appId: this._resolvedInputs.appId,
                    envId: this.api.envId,
                    type: 'WEB',
                    mode: this._resolvedInputs.deployOptions.mode === lowcode_builder_1.DEPLOY_MODE.UPLOAD ? lowcode_deployer_1.EDeployMode.PRODUCTION : lowcode_deployer_1.EDeployMode.PREVIEW,
                    projectPath: path_1.default.resolve(this.api.projectPath, exports.DIST_PATH),
                    credential,
                    ignores: ['.git', '.github', 'node_modules', 'cloudbaserc.js', LOG_FILE, DEFAULT_CLOUDFUNCTION_ROOT_NAME],
                    webOptions: {
                        cloudPath: this._getWebRootPath({
                            appId: this._resolvedInputs.appId,
                            name: (_c = this._resolvedInputs.mainAppSerializeData) === null || _c === void 0 ? void 0 : _c.name,
                            deployOptions: this._resolvedInputs.deployOptions,
                        }),
                        buildTypeList: this._resolvedInputs.buildTypeList,
                        credential,
                        gatewayConfig: this._gatewayConfig
                            ? {
                                domain: this._gatewayConfig.Domain,
                                path: this._gatewayConfig.Path,
                            }
                            : undefined,
                    },
                    artifactOptions: this._artifactOptions,
                });
            }
        });
    }
    _getWebRootPath({ appId, name = '', deployOptions }) {
        const key = name || appId;
        return (deployOptions === null || deployOptions === void 0 ? void 0 : deployOptions.mode) === lowcode_builder_1.DEPLOY_MODE.UPLOAD ? `/${key}/production/` : `/${key}/preview/`;
    }
    _time(label) {
        if (!this._timeMap[label]) {
            this._timeMap[label] = Date.now();
        }
    }
    _timeEnd(label) {
        let startTime = this._timeMap[label];
        if (startTime) {
            let delta = Date.now() - startTime;
            return parseFloat((delta / 1000).toPrecision(2));
        }
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            const { envId } = this.api;
            const { appId, mainAppSerializeData } = this._resolvedInputs;
            let name = '';
            if (appId) {
                try {
                    const { Weapps = [] } = yield this.api.cloudbaseManager.commonService('lowcode', '2021-01-08').call({
                        Action: 'DescribeApps',
                        Param: {
                            EnvId: this.api.envId,
                            AppIds: [appId],
                            Offset: 0,
                            Limit: 1,
                        },
                    });
                    const item = Weapps.find((item) => item.Id === appId);
                    if (!item) {
                        throw new Error(`Resource ${appId} not found'`);
                    }
                    name = item.Name;
                }
                catch (e) {
                    this.api.logger.error('get app name error', e);
                }
            }
            mainAppSerializeData.name = name;
            this._resolvedInputs = (0, lowcode_builder_1.normalizeInputs)(this._resolvedInputs, {
                envId,
                getWebRootPath: ({ appId, name, deployOptions }) => {
                    return this._getWebRootPath({ appId, name, deployOptions });
                },
            });
            if (!(0, lowcode_builder_1.buildAsWebByBuildType)(this._resolvedInputs.buildTypeList)) {
                const { mpDeployPrivateKey, deployOptions } = this._resolvedInputs;
                if (deployOptions.mpDeployPrivateKey === undefined) {
                    deployOptions.mpDeployPrivateKey = mpDeployPrivateKey;
                }
            }
            this._initDir();
        });
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () { });
    }
    remove() {
        return __awaiter(this, void 0, void 0, function* () { });
    }
    genCode() {
        return __awaiter(this, void 0, void 0, function* () { });
    }
    build() {
        var _a, _b, _c, _d, _e;
        return __awaiter(this, void 0, void 0, function* () {
            let { logger } = this.api;
            const staticDir = path_1.default.resolve(__dirname, '../../../static');
            let { debug, subAppSerializeDataList, dependencies, appId, buildTypeList, generateMpType, plugins, extraData, runtimeEndpointType, } = this._resolvedInputs;
            const webpackMode = ((_a = this._resolvedInputs.deployOptions) === null || _a === void 0 ? void 0 : _a.mode) === lowcode_builder_1.DEPLOY_MODE.UPLOAD
                ? lowcode_builder_1.WebpackModeType.PRODUCTION
                : lowcode_builder_1.WebpackModeType.NONE;
            let miniAppDir = '';
            let webAppDir = '';
            const { envId } = this.api;
            const [hostingRes, expiredTimeOrAd, uin, privatelinkConfig] = yield Promise.all([
                this._getHostingInfoTask(envId, true).catch((e) => {
                    this.api.logger.error('获取静态托管失败: ', e);
                    throw e;
                }),
                this._enableExpireTime(envId),
                this.api.cloudbaseManager
                    .commonService('cam', '2019-01-16')
                    .call({
                    Action: 'GetUserAppId',
                    Param: {},
                })
                    .then(({ OwnerUin }) => OwnerUin, (e) => {
                    return null;
                }),
                this._getPrivateConfig(envId, appId),
            ]);
            const [website] = hostingRes;
            this._website = website;
            const domain = ((_b = this._website) === null || _b === void 0 ? void 0 : _b.cdnDomain) || ((_c = this._resolvedInputs.mainAppSerializeData.extra) === null || _c === void 0 ? void 0 : _c.domain);
            let __defaultLoginType__;
            if ((0, lowcode_builder_1.buildAsWebByBuildType)(buildTypeList)) {
                let { appConfig = {} } = this._resolvedInputs.mainAppSerializeData.extra;
                let { window = {} } = appConfig;
                if (!(0, lowcode_builder_1.buildAsXPageByBuildType)(buildTypeList)) {
                    if (domain) {
                        if (!this._resolvedInputs.mainAppSerializeData.extra) {
                            this._resolvedInputs.mainAppSerializeData.extra = {};
                        }
                        this._resolvedInputs.mainAppSerializeData.extra.domain = domain;
                    }
                    try {
                        const EnvType_MAP = {
                            [lowcode_builder_1.DEPLOY_MODE.PREVIEW]: 'pre',
                            [lowcode_builder_1.DEPLOY_MODE.UPLOAD]: 'prod',
                        };
                        const { Data = {} } = yield this.api.cloudbaseManager.commonService('lowcode', '2021-01-08').call({
                            Action: 'DescribeAppCustomUrls',
                            Param: {
                                EnvId: this.api.envId,
                                IgnorePublished: true,
                                WeAppId: appId,
                            },
                        });
                        this._gatewayConfig = (_e = (_d = Data === null || Data === void 0 ? void 0 : Data.Items) === null || _d === void 0 ? void 0 : _d.find) === null || _e === void 0 ? void 0 : _e.call(_d, (item) => item.EnvType === EnvType_MAP[this._resolvedInputs.deployOptions.mode]);
                        this.api.logger.debug('DescribeAppCustomUrls:', Data === null || Data === void 0 ? void 0 : Data.Items, this._gatewayConfig);
                        if (this._gatewayConfig) {
                            const path = this._gatewayConfig.Path;
                            window.publicPath = `https://${domain}${this._getWebRootPath({
                                appId: this._resolvedInputs.appId,
                                name: this._resolvedInputs.mainAppSerializeData.name,
                                deployOptions: this._resolvedInputs.deployOptions,
                            })}`;
                            if (!(0, lowcode_builder_1.buildAsAdminPortalByBuildType)(buildTypeList)) {
                                window.basename = path;
                                window._indexPage = true;
                            }
                        }
                    }
                    catch (e) {
                        this.api.logger.error('路由失败', e, {
                            EnvId: this.api.envId,
                            WeAppId: appId,
                        });
                    }
                }
                appConfig.window = window;
                this._resolvedInputs.mainAppSerializeData.extra.appConfig = appConfig;
            }
            else {
                try {
                    const { Data = [], RequestId } = yield this.api.cloudbaseManager.commonService('tcb', '2018-06-08').call({
                        Action: 'GetProviders',
                        Param: {
                            EnvId: envId,
                        },
                    });
                    this.api.logger.info('GetProviders res', RequestId);
                    const find = Data.find((item) => item.ProviderType === 'WX_CLOUDBASE_MICRO_APP' && item.On === 'TRUE');
                    if (find) {
                        __defaultLoginType__ = 'openId';
                    }
                }
                catch (e) {
                    this.api.logger.error('GetProviders error', e);
                }
            }
            try {
                if (!debug) {
                    pauseConsoleOutput();
                }
                this._time("build process");
                this._appPath = yield new Promise((resolve, reject) => {
                    try {
                        (0, lowcode_builder_1.buildWedaApp)({
                            cals: this._resolvedInputs.mainAppSerializeData,
                            subAppCalsList: subAppSerializeDataList,
                            dependencies,
                            appKey: appId,
                            runtime: this._resolvedInputs.runtime,
                            ignoreInstall: this._resolvedInputs.ignoreInstall,
                            buildTypeList,
                            mode: webpackMode,
                            deployOptions: this._resolvedInputs.deployOptions,
                            runtimeOptions: this._resolvedInputs.runtimeOptions,
                            generateMpType,
                            plugins,
                            extraData,
                            resourceAppId: this._resolvedInputs.mpAppId,
                            domain,
                            endpointType: runtimeEndpointType,
                            enableAd: expiredTimeOrAd === 'mp_exp',
                            enableExpiredTag: expiredTimeOrAd === 'exp',
                            account: { uin },
                            privatelinkConfig,
                            __defaultLoginType__,
                        }, (err, result) => __awaiter(this, void 0, void 0, function* () {
                            if (!err) {
                                try {
                                    const { appConfig = {} } = this._resolvedInputs.mainAppSerializeData.extra;
                                    const { publicPath = '' } = (appConfig === null || appConfig === void 0 ? void 0 : appConfig.window) || {};
                                    const { outDir = '', timeElapsed = 0 } = result || {};
                                    if (buildTypeList.includes(lowcode_builder_1.BuildType.MP)) {
                                        miniAppDir = outDir;
                                    }
                                    if ((0, lowcode_builder_1.buildAsWebByBuildType)(buildTypeList)) {
                                        webAppDir = path_1.default.resolve(outDir, 'preview');
                                    }
                                    logger.debug(`=== Compilation finished at ${outDir}, elapsed time: ${timeElapsed / 1000}s.===\n`);
                                    let distPath = path_1.default.resolve(this.api.projectPath, exports.DIST_PATH);
                                    if (miniAppDir) {
                                        fs_extra_1.default.copySync(miniAppDir, distPath);
                                    }
                                    else if (webAppDir) {
                                        const staticAppDir = path_1.default.join(staticDir, publicPath);
                                        fs_extra_1.default.ensureDirSync(staticAppDir);
                                        fs_extra_1.default.copySync(webAppDir, distPath);
                                    }
                                    resolve(distPath);
                                }
                                catch (e) {
                                    reject(e);
                                    throw e;
                                }
                            }
                            else {
                                reject(err);
                            }
                        }));
                    }
                    catch (e) {
                        reject(e);
                    }
                });
                if (!debug) {
                    resumeConsoleOutput();
                }
                logger.info(`code generated successfully, cost ${this._timeEnd("build process")}s: ${this._appPath}`);
                yield this._subPluginConstructor(this._resolvedInputs);
                if (this._miniprogramePlugin) {
                    this._time("build mp plugin");
                    yield this._miniprogramePlugin.init();
                    yield this._miniprogramePlugin.build();
                    logger.debug(`miniprograme plugin build cost ${this._timeEnd("build mp plugin")}s`);
                }
            }
            catch (e) {
                if (debug) {
                    yield this._debugInfo();
                }
                logger.info(`low-code build fail: ${e}`);
                throw e;
            }
            logger.info(`low-code build end: ${this._appPath}`);
            return this._appPath;
        });
    }
    compile() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                this._time("compile");
                let res = {};
                try {
                    yield this.api.cloudbaseManager.commonService('lowcode', '2021-01-08').call({
                        Action: 'UpdateLoginConfig',
                        Param: { EnvId: this.api.envId },
                    });
                    this.api.logger.debug('login config set success');
                }
                catch (e) {
                    this.api.logger.error('设置登录配置失败', e);
                }
                if (this._miniprogramePlugin) {
                    res = (0, lodash_1.merge)(res, yield this._miniprogramePlugin.compile());
                }
                else if ((0, lowcode_builder_1.buildAsWebByBuildType)(this._resolvedInputs.buildTypeList)) {
                    yield this._deployer.deploy({ version: (_a = this._resolvedInputs.deployOptions) === null || _a === void 0 ? void 0 : _a.version });
                }
                if (!Object.keys(res.Resources || {}).length && !Object.keys(res.Config || {}).length) {
                    this._skipInstallExt = true;
                }
                this.api.logger.info(`compile end, cost ${this._timeEnd("compile")}s: `, res);
                return res;
            }
            catch (e) {
                if (this._resolvedInputs.debug) {
                    yield this._debugInfo();
                }
                throw e;
            }
        });
    }
    deploy() {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const isAdminPortal = (0, lowcode_builder_1.buildAsAdminPortalByBuildType)(this._resolvedInputs.buildTypeList);
                this._time("DEPLOY");
                if (this._miniprogramePlugin) {
                    yield this._miniprogramePlugin.deploy();
                }
                if (this._enablePrivatelink) {
                    if (this._privatelinkGatewayMeta) {
                        if (!isAdminPortal) {
                            try {
                                const res = yield this.api.cloudbaseManager.commonService('lowcode', '2021-01-08').call({
                                    Action: 'BindGatewayAppDomain',
                                    Param: {
                                        GatewayEnvId: this._privatelinkGatewayMeta.gatewayEnvId,
                                        GatewayId: this._privatelinkGatewayMeta.gatewayId,
                                        Domain: this._privatelinkGatewayMeta.domain,
                                        EnvId: this.api.envId,
                                        Target: 'domain_app',
                                        WeAppId: isAdminPortal ? 'app_enterprise' : this._resolvedInputs.appId,
                                        PubPlatform: (0, lowcode_builder_1.buildAsWebByBuildType)(this._resolvedInputs.buildTypeList) ? 'web' : 'minapp',
                                        PubEnvType: ((_a = this._resolvedInputs.deployOptions) === null || _a === void 0 ? void 0 : _a.mode) === lowcode_builder_1.DEPLOY_MODE.UPLOAD ? 'prod' : 'pre',
                                    },
                                });
                                this.api.logger.info('BindGatewayAppDomain:', res);
                            }
                            catch (e) {
                                this.api.logger.error('BindGatewayAppDomain:', e);
                            }
                        }
                    }
                    else {
                        try {
                            const res = yield this.api.cloudbaseManager.commonService('lowcode', '2021-01-08').call({
                                Action: 'UpdateAppDomainInvalid',
                                Param: {
                                    EnvId: this.api.envId,
                                    WeAppId: isAdminPortal ? 'app_enterprise' : this._resolvedInputs.appId,
                                    PubPlatform: (0, lowcode_builder_1.buildAsWebByBuildType)(this._resolvedInputs.buildTypeList) ? 'web' : 'minapp',
                                    PubEnvType: ((_b = this._resolvedInputs.deployOptions) === null || _b === void 0 ? void 0 : _b.mode) === lowcode_builder_1.DEPLOY_MODE.UPLOAD ? 'prod' : 'pre',
                                },
                            });
                            this.api.logger.info('UpdateAppDomainInvalid:', res);
                        }
                        catch (e) {
                            this.api.logger.error('UpdateAppDomainInvalid:', e);
                        }
                    }
                }
                if (this._skipInstallExt) {
                    try {
                        yield this.api.cloudApi.tcbService.request('CloudBaseCIResultCallback', {
                            CIID: this.api.ciId,
                            TraceId: this.api.ciId,
                            Status: 0,
                        });
                        this.api.logger.debug('回调云项目成功');
                    }
                    catch (e) {
                        this.api.logger.error('通知云项目状态失败[CloudBaseCIResultCallback]', e);
                    }
                }
                this.api.logger.info(`${this.api.emoji('🚀')} low - code deploy end, cost ${this._timeEnd("DEPLOY")}s`);
            }
            catch (e) {
                throw e;
            }
            finally {
                this.api.logger.debug(`low-code plugin takes ${this._timeEnd("low code lifetime")}s to run.`);
                if (this._resolvedInputs.debug) {
                    yield this._debugInfo();
                }
                if (this._resolvedInputs.runtime === lowcode_builder_1.RUNTIME.CI) {
                    yield this._postPersistentDependiences();
                }
            }
            return;
        });
    }
    _getHostingInfoTask(envId, loose = false) {
        return __awaiter(this, void 0, void 0, function* () {
            let timeout = null;
            let [website, hostingDatas] = yield Promise.race([
                new Promise((resolve) => {
                    timeout = setTimeout(() => {
                        resolve([]);
                    }, 300 * 1000);
                }),
                this._getHostingInfo(envId, loose),
            ]);
            if (timeout) {
                clearTimeout(timeout);
            }
            return [website, hostingDatas];
        });
    }
    _getHostingInfo(envId, loose = false) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const HostingProvider = (_a = this.api.resourceProviders) === null || _a === void 0 ? void 0 : _a.hosting;
            let [website, hostingDatas] = yield HostingProvider.getHostingInfo({
                envId,
            }).then(({ data: hostingDatas }) => {
                let website = hostingDatas[0];
                return [website, hostingDatas];
            });
            if (!website || (loose ? false : (website === null || website === void 0 ? void 0 : website.status) !== 'online')) {
                yield new Promise((resolve) => {
                    setTimeout(() => {
                        resolve(true);
                    }, 8 * 1000);
                });
                return this._getHostingInfo(envId, loose);
            }
            else {
                return [website, hostingDatas];
            }
        });
    }
    _enableExpireTime(envId) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const { EnvList = [] } = yield this.api.cloudbaseManager.commonService('tcb', '2018-06-08').call({
                    Action: 'DescribeEnvs',
                    Param: {
                        EnvId: envId,
                    },
                });
                const envType = (_a = EnvList === null || EnvList === void 0 ? void 0 : EnvList[0]) === null || _a === void 0 ? void 0 : _a.EnvType;
                if (envType === 'baas') {
                    const { EnvBillingInfoList = [] } = yield this.api.cloudbaseManager
                        .commonService('tcb', '2018-06-08')
                        .call({
                        Action: 'DescribeBillingInfo',
                        Param: {
                            EnvId: envId,
                        },
                    })
                        .catch((e) => {
                        this.api.logger.error('DescribeBillingInfo error: ', e);
                        throw e;
                    });
                    this.api.logger.info('DescribeBillingInfo data: ', (_b = EnvBillingInfoList === null || EnvBillingInfoList === void 0 ? void 0 : EnvBillingInfoList[0]) === null || _b === void 0 ? void 0 : _b.EnvCharged);
                    if (((_c = EnvBillingInfoList === null || EnvBillingInfoList === void 0 ? void 0 : EnvBillingInfoList[0]) === null || _c === void 0 ? void 0 : _c.EnvCharged) === 'yes') {
                        return false;
                    }
                }
                const [{ Resources = [] }, isOperationAppUser] = yield Promise.all([
                    this.api.cloudbaseManager
                        .commonService('tcb', '2018-06-08')
                        .call({
                        Action: 'DescribeCommonBillingResources',
                        Param: {
                            EnvId: envId,
                            ProductCode: 'p_lcap',
                            SubProductCode: 'sp_lcap_base',
                            StatusList: ['normal'],
                        },
                    })
                        .catch((e) => {
                        this.api.logger.error('查询校验套餐失败: ', e);
                        throw e;
                    }),
                    this.api.cloudbaseManager
                        .commonService('tcb', '2018-06-08')
                        .call({
                        Action: 'GetOperationAppUser',
                        Param: {
                            EnvId: envId,
                        },
                    })
                        .catch((e) => {
                        if (e.code !== `ResourceNotFound.UserNotExists`) {
                            this.api.logger.error('查询工具箱环境失败: ', e);
                            throw e;
                        }
                        else {
                            return false;
                        }
                    }),
                ]);
                const list = Resources.sort((a, b) => {
                    let atimesnap;
                    let btimesnap;
                    try {
                        atimesnap = new Date(a.BillTime).getTime();
                    }
                    catch (e) {
                        atimesnap = Infinity;
                    }
                    try {
                        btimesnap = new Date(b.BillTime).getTime();
                    }
                    catch (e) {
                        btimesnap = Infinity;
                    }
                    return atimesnap - btimesnap > 0 ? -1 : 1;
                });
                if (envType === 'baas' && !list.length) {
                    return 'mp_exp';
                }
                if (list[0]) {
                    const { SubBillingItemCode = [] } = list[0];
                    const exp = SubBillingItemCode.find((item) => {
                        return item.Code === 'sv_lcap_generic_experience' && item.Num && Number(item.Num) > 0;
                    });
                    const mp_exp = SubBillingItemCode.find((item) => {
                        return item.Code === 'sv_lcap_generic_wx_experience' && item.Num && Number(item.Num) > 0;
                    });
                    if (envType === 'baas' && (exp || mp_exp)) {
                        return 'mp_exp';
                    }
                    if (exp && !isOperationAppUser) {
                        return 'exp';
                    }
                    else if (mp_exp) {
                        return 'mp_exp';
                    }
                }
            }
            catch (e) { }
            return false;
        });
    }
    _getPrivateConfig(envId, appId) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this._enablePrivatelink) {
                return undefined;
            }
            const isAdminPortal = (0, lowcode_builder_1.buildAsAdminPortalByBuildType)(this._resolvedInputs.buildTypeList);
            const gatewayMeta = yield this.api.cloudbaseManager
                .commonService('lowcode', '2021-01-08')
                .call({
                Action: 'GetGatewayDomainAppDetails',
                Param: {
                    EnvId: envId,
                    WeAppId: isAdminPortal ? 'app_enterprise' : appId,
                },
            })
                .then((res) => {
                this.api.logger.info(`GetGatewayDomainAppDetails success:${res.RequestId}`);
                const { Domain, GatewayId, GatewayEnvId, BindDomainAppList = [] } = res;
                const item = BindDomainAppList.find((item) => item.WeAppId === appId || (isAdminPortal ? item.WeAppId === 'app_enterprise' : false));
                if (Domain && GatewayId && (item === null || item === void 0 ? void 0 : item.IsBindDomain)) {
                    return {
                        gatewayId: GatewayId,
                        gatewayEnvId: GatewayEnvId,
                        domain: Domain,
                    };
                }
            })
                .catch((e) => {
                this.api.logger.error(`GetGatewayDomainAppDetails error`, {
                    code: e.code,
                    message: e.message,
                    requestId: e.requestId,
                });
                return undefined;
            });
            if (!gatewayMeta) {
                return undefined;
            }
            this._privatelinkGatewayMeta = gatewayMeta;
            const { gatewayId, domain, gatewayEnvId } = gatewayMeta;
            const [enableSSL, publicKey] = yield Promise.all([
                Promise.resolve(true),
                this.api.cloudbaseManager
                    .commonService('tcb', '2018-06-08')
                    .call({
                    Action: 'DescribeGatewayRsaKeys',
                    Param: {
                        EnvId: gatewayEnvId,
                        GatewayId: gatewayId,
                    },
                })
                    .then((res) => {
                    var _a, _b;
                    const { RsaKeys } = res;
                    if (!((_a = RsaKeys === null || RsaKeys === void 0 ? void 0 : RsaKeys[0]) === null || _a === void 0 ? void 0 : _a.PublicKey)) {
                        throw new Error('私密链路未找到公钥配置');
                    }
                    return (_b = RsaKeys === null || RsaKeys === void 0 ? void 0 : RsaKeys[0]) === null || _b === void 0 ? void 0 : _b.PublicKey;
                }),
            ]);
            const privateConfig = {
                gatewayId,
                host: domain,
                port: enableSSL ? '443' : '80',
                publicKey,
            };
            this.api.logger.info('getPrivateConfig', privateConfig);
            return privateConfig;
        });
    }
    _checkIsVersion(version) {
        return version === 'latest' || String(version).startsWith('2');
    }
    _postPersistentDependiences() {
        return __awaiter(this, void 0, void 0, function* () {
            let promises = [];
            let cos = this._initCos();
            promises = Object.keys(lowcode_builder_1.PERSISTENT_DEPENDIENCES_MAP).map((key) => __awaiter(this, void 0, void 0, function* () {
                let meta = lowcode_builder_1.PERSISTENT_DEPENDIENCES_MAP[key];
                const zipPath = path_1.default.join(this.api.projectPath, `${meta.name}@${meta.version}.zip`);
                try {
                    yield this._zipDir(meta.source, zipPath);
                    const matched = meta.downloadUrl.match(/^https?:\/\/(.*?)\.cos\.(.*?)\.myqcloud.com\/(.*)$/);
                    if (matched) {
                        const [_, bucket, region, cosKey] = matched;
                        this.api.logger.debug(`解析持久化地址`, matched);
                        if (bucket && region && cosKey) {
                            yield new Promise((resolve, reject) => {
                                cos.putObject({
                                    Bucket: bucket,
                                    Region: region,
                                    Key: cosKey,
                                    Body: fs_extra_1.default.createReadStream(zipPath),
                                }, (err, data) => {
                                    if (err) {
                                        reject(err);
                                    }
                                    else {
                                        resolve(data);
                                    }
                                });
                            });
                            this.api.logger.error(`持久化组件库${meta.name}@${meta.version}成功`);
                        }
                    }
                }
                catch (e) {
                    this.api.logger.error(`持久化组件库${meta.name}@${meta.version}失败：`, e);
                }
                return true;
            }));
            this.api.logger.info(`开始持久化组件库...`);
            yield Promise.all(promises);
        });
    }
    _debugInfo() {
        return __awaiter(this, void 0, void 0, function* () {
            fs_extra_1.default.ensureDirSync(path_1.default.resolve(this.api.projectPath, DEBUG_PATH));
            let _a = this._originInputsStr ? JSON.parse(this._originInputsStr) : this._resolvedInputs, { mpDeployPrivateKey, deployOptions, credential: _, storage: __ } = _a, rest = __rest(_a, ["mpDeployPrivateKey", "deployOptions", "credential", "storage"]);
            const _b = deployOptions || {}, { mpDeployPrivateKey: _key } = _b, restDeployOptions = __rest(_b, ["mpDeployPrivateKey"]);
            if (this._artifactOptions) {
                let cos = this._initCos();
                try {
                    yield Promise.race([
                        new Promise((resolve, reject) => {
                            setTimeout(() => {
                                reject(new Error('上传构建快照超时'));
                            }, 10000);
                        }),
                        new Promise((resolve, reject) => {
                            var _a, _b, _c;
                            cos.putObject({
                                Bucket: ((_a = this._artifactOptions) === null || _a === void 0 ? void 0 : _a.bucket) || '',
                                Region: ((_b = this._artifactOptions) === null || _b === void 0 ? void 0 : _b.region) || '',
                                Key: `${(_c = this._artifactOptions) === null || _c === void 0 ? void 0 : _c.baseKey}/input.json`,
                                Body: Buffer.from(JSON.stringify(Object.assign(Object.assign({}, rest), { deployOptions: restDeployOptions }), undefined, 2)),
                            }, (err, data) => {
                                if (err) {
                                    reject(err);
                                }
                                else {
                                    resolve(data);
                                }
                            });
                        }),
                    ]);
                    if (process.env.CODE_URL_WITH_AUTH && process.env.CLOUDBASE_CIID) {
                        const { pathname, hostname } = new URL(process.env.CODE_URL_WITH_AUTH);
                        if (/ci-source(-replace)?-1303824488\./.test(hostname) &&
                            new RegExp(`^/lca/${this._resolvedInputs.appId}`).test(pathname)) {
                            yield Promise.race([
                                new Promise((resolve, reject) => {
                                    setTimeout(() => {
                                        reject(new Error('删除快照超时'));
                                    }, 10000);
                                }),
                                new Promise((resolve, reject) => {
                                    var _a, _b;
                                    cos.deleteObject({
                                        Bucket: ((_a = this._artifactOptions) === null || _a === void 0 ? void 0 : _a.bucket) || '',
                                        Region: ((_b = this._artifactOptions) === null || _b === void 0 ? void 0 : _b.region) || '',
                                        Key: pathname.replace(/^\//, ''),
                                    }, (err, data) => {
                                        if (err) {
                                            reject(err);
                                        }
                                        else {
                                            resolve(data);
                                        }
                                    });
                                }),
                            ]);
                        }
                    }
                    this.api.logger.info(`上传构建快照成功`);
                }
                catch (e) {
                    this.api.logger.error(`上传构建快照失败：`, e);
                }
            }
        });
    }
    _zipDir(src, dist) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                let output = fs_extra_1.default.createWriteStream(dist);
                let archive = (0, archiver_1.default)('zip', {
                    zlib: { level: 9 },
                });
                output.on('close', resolve);
                archive.on('error', reject);
                archive.directory(src, false);
                archive.pipe(output);
                archive.finalize();
            });
        });
    }
    _initCos() {
        let { credential } = this._resolvedInputs;
        return (credential === null || credential === void 0 ? void 0 : credential.token)
            ? new cos_nodejs_sdk_v5_1.default({
                getAuthorization(options, callback) {
                    callback({
                        TmpSecretId: (credential === null || credential === void 0 ? void 0 : credential.secretId) || '',
                        TmpSecretKey: (credential === null || credential === void 0 ? void 0 : credential.secretKey) || '',
                        XCosSecurityToken: (credential === null || credential === void 0 ? void 0 : credential.token) || '',
                        ExpiredTime: Math.floor(Date.now() / 1000) + 600,
                        StartTime: Math.floor(Date.now() / 1000),
                    });
                },
            })
            : new cos_nodejs_sdk_v5_1.default({
                SecretId: credential === null || credential === void 0 ? void 0 : credential.secretId,
                SecretKey: credential === null || credential === void 0 ? void 0 : credential.secretKey,
            });
    }
}
function resolveInputs(inputs, defaultInputs) {
    return Object.assign({}, defaultInputs, inputs);
}
const originalStdoutWrite = process.stdout.write.bind(process.stdout);
const originalStderrWrite = process.stderr.write.bind(process.stderr);
let previousStdoutWrite = process.stdout.write.bind(process.stdout);
let previousStderrWrite = process.stderr.write.bind(process.stderr);
function pauseConsoleOutput() {
    previousStdoutWrite = process.stdout.write;
    process.stdout.write = () => true;
    previousStderrWrite = process.stderr.write.bind(process.stderr);
    process.stderr.write = () => true;
}
function resumeConsoleOutput(original = false) {
    if (original) {
        process.stdout.write = originalStdoutWrite;
        process.stderr.write = originalStderrWrite;
    }
    else {
        process.stdout.write = previousStdoutWrite;
        process.stderr.write = previousStderrWrite;
    }
}
exports.plugin = LowCodePlugin;
