import { Plugin, PluginServiceApi } from '@cloudbase/framework-core';
interface IFrameworkPluginMiniProgramInputs {
    appid: string;
    privateKeyPath: string;
    privateKey?: string;
    localPath: string;
    ignores?: string[];
    deployMode?: 'preview' | 'upload';
    previewOptions?: IMiniProgramPreviewOptions;
    uploadOptions?: IMiniProgramUploadOptions;
    commands?: Record<string, string>;
    artifactOptions?: any;
    deployerOprions: {
        appId: string;
        envId: string;
        credential: any;
    };
}
interface IMiniProgramUploadOptions {
    version?: string;
    desc?: string;
    setting?: IMiniProgramBuildSetting;
    allowIgnoreUnusedFiles?: boolean;
}
interface IMiniProgramPreviewOptions {
    desc?: string;
    setting?: IMiniProgramBuildSetting;
    qrcodeOutputPath?: string;
    pagePath?: string;
    searchQuery?: string;
    scene?: number;
    allowIgnoreUnusedFiles?: boolean;
}
interface IMiniProgramBuildSetting {
    es6?: boolean;
    minify?: boolean;
    codeProtect?: boolean;
}
interface IMiniProgramBuildOutput {
    link?: string;
    version?: string;
}
declare class MiniProgramsPlugin extends Plugin {
    name: string;
    api: PluginServiceApi;
    inputs: IFrameworkPluginMiniProgramInputs;
    protected resolvedInputs: IFrameworkPluginMiniProgramInputs;
    protected buildOutput: IMiniProgramBuildOutput;
    protected deployer: any;
    constructor(name: string, api: PluginServiceApi, inputs: IFrameworkPluginMiniProgramInputs);
    init(): Promise<void>;
    _initCI(): void;
    run(): Promise<void>;
    remove(): Promise<void>;
    genCode(): Promise<void>;
    build(): Promise<void>;
    compile(): Promise<{}>;
    deploy(): Promise<void>;
}
export declare const plugin: typeof MiniProgramsPlugin;
export {};
//# sourceMappingURL=mpPlugin.d.ts.map